package com.yunzhi.marketing.xlk.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 客户到访单 
 * </p>
 *
 * @author jobob
 * @since 2021-07-30
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("xlk_customer_visit")
public class CustomerVisit implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 客户到访id
     */
    @TableId(type = IdType.UUID)
    private String customerVisitId;

    /**
     * 客户id
     */
    private String customerId;

    /**
     * 楼盘id
     */
    private String buildingId;

    /**
     * 客户姓名
     */
    private String name;

    /**
     * 推荐人（归属渠道）
     */
    private String recommendPerson;

    /**
     * 推荐人姓名（归属渠道）
     */
    private String recommendName;

    /**
     * 内场接待（置业顾问）
     */
    private String realtyConsultant;

    /**
     * 内场接待（置业顾问）姓名
     */
    private String realtyConsultantName;

    /**
     * 创建时间
     */
    private LocalDateTime createDate;

    /**
     * 到访照片
     */
    private String imageUrl;

    /**
     * 备注
     */
    private String remark;

    /**
     * 公司id
     */
    private Integer orgId;

    /**
     * 渠道 ID
     */
    private Integer channelId;

    private LocalDateTime visitDate;

    private String channelCustomerId;
}
